Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialHelper.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialHelper.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialHelper.java	(revision 43377)
@@ -0,0 +1,399 @@
+/* gvSIG. Geographic Information System of the Valencian Government
+ *
+ * Copyright (C) 2007-2016 Infrastructures and Transports Department
+ * of the Valencian Government (CIT)
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 3
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+ * MA  02110-1301, USA.
+ *
+ */
+package org.gvsig.fmap.dal.store.h2;
+
+import java.sql.Connection;
+import java.sql.SQLException;
+import java.text.MessageFormat;
+import org.apache.commons.dbcp.BasicDataSource;
+import org.apache.commons.io.FilenameUtils;
+import org.apache.commons.lang3.StringUtils;
+import org.cresques.cts.IProjection;
+import org.gvsig.fmap.dal.SQLBuilder;
+import org.gvsig.fmap.dal.resource.exception.AccessResourceException;
+import org.gvsig.fmap.dal.store.h2.operations.H2SpatialOperationsFactory;
+import org.gvsig.fmap.dal.store.jdbc.JDBCConnectionParameters;
+import org.gvsig.fmap.dal.store.jdbc.JDBCNewStoreParameters;
+import org.gvsig.fmap.dal.store.jdbc.JDBCServerExplorerParameters;
+import org.gvsig.fmap.dal.store.jdbc.JDBCStoreParameters;
+import org.gvsig.fmap.dal.store.jdbc.exception.JDBCDriverClassNotFoundException;
+import org.gvsig.fmap.dal.store.jdbc2.OperationsFactory;
+import org.gvsig.fmap.dal.store.jdbc2.spi.JDBCHelperBase;
+import org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase;
+import org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSRSsBase;
+import org.gvsig.fmap.geom.Geometry;
+import org.gvsig.fmap.geom.aggregate.MultiLine;
+import org.gvsig.fmap.geom.aggregate.MultiPoint;
+import org.gvsig.fmap.geom.aggregate.MultiPolygon;
+import org.gvsig.fmap.geom.exception.CreateGeometryException;
+import org.gvsig.fmap.geom.primitive.Primitive;
+import org.gvsig.fmap.geom.type.GeometryType;
+import org.h2gis.ext.H2GISExtension;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+public class H2SpatialHelper extends JDBCHelperBase {
+
+    static final Logger logger = LoggerFactory.getLogger(H2SpatialHelper.class);
+
+    public static final String H2SpatialJDBCDriver = "org.h2.Driver";
+
+    public static String getConnectionURL(H2SpatialConnectionParameters params) {
+        String connectionURL;
+        if( StringUtils.isEmpty(params.getHost()) ) {
+            // Asumimos que es una conexion directa sobre el filesystem
+            String dbname = params.getFile().getAbsolutePath().replace("\\","/");
+            if( StringUtils.equalsIgnoreCase(FilenameUtils.getExtension(params.getFile().getName()),"zip") ) {
+                connectionURL =  MessageFormat.format(
+                    "jdbc:h2:zip:{0}!/{1};MODE=PostgreSQL",
+                    dbname,
+                    params.getDBName()
+                );
+            } else {
+                if( dbname.endsWith(".mv.db") ) {
+                    dbname = dbname.substring(0, dbname.length()-6);
+                }
+                connectionURL =  MessageFormat.format(
+                    "jdbc:h2:file:{0};MODE=PostgreSQL",
+                    dbname
+                );
+            }
+        } else if( params.getPort() == null ) {
+            connectionURL =  MessageFormat.format(
+                "jdbc:h2:tcp://{0}/{1};MODE=PostgreSQL",
+                params.getHost(),
+                params.getDBName()
+            );            
+        } else {
+            connectionURL =  MessageFormat.format(
+                "jdbc:h2:tcp://{0}:{1,number,#######}/{2};MODE=PostgreSQL",
+                params.getHost(),
+                params.getPort().intValue(),
+                params.getDBName()
+            );
+        }
+        logger.debug("connectionURL: {}", connectionURL);
+        return connectionURL;
+    }
+
+    private static class ConnectionProvider {
+
+        private static boolean needRegisterDriver = true;
+
+        private BasicDataSource dataSource = null;
+
+        private final H2SpatialConnectionParameters connectionParameters;
+
+        public ConnectionProvider(H2SpatialConnectionParameters connectionParameters) {
+            this.connectionParameters = connectionParameters;
+        }
+
+        public Connection getConnection() throws SQLException {
+            if (this.dataSource == null) {
+                this.dataSource = this.createDataSource();               
+            }
+            Connection conn = this.dataSource.getConnection();
+            try {
+                conn.createStatement().execute("SELECT TOP 1 SRID FROM SPATIAL_REF_SYS");
+            } catch(SQLException ex) {
+                H2GISExtension.load(conn);
+            }
+            return conn;
+        }
+
+        private BasicDataSource createDataSource() throws SQLException {
+            if (!this.isRegistered()) {
+                this.registerDriver();
+            }
+            H2SpatialConnectionParameters params = connectionParameters;
+
+            BasicDataSource ds = new BasicDataSource();
+            ds.setDriverClassName(params.getJDBCDriverClassName());
+            if( !StringUtils.isEmpty(params.getUser()) ) {
+                ds.setUsername(params.getUser());
+            }
+            if( !StringUtils.isEmpty(params.getPassword()) ) {
+                ds.setPassword(params.getPassword());
+            }
+            ds.setUrl(params.getUrl());
+
+            ds.setMaxWait(60L * 1000);
+            return ds;
+        }
+
+        private boolean isRegistered() {
+            return needRegisterDriver;
+        }
+
+        public void registerDriver() throws SQLException {
+            String className = this.connectionParameters.getJDBCDriverClassName();
+            if (className == null) {
+                return;
+            }
+            try {
+                Class theClass = Class.forName(className);
+                if (theClass == null) {
+                    throw new JDBCDriverClassNotFoundException(H2SpatialLibrary.NAME, className);
+                }
+            } catch (Exception e) {
+                throw new SQLException("Can't register JDBC driver '" + className + "'.", e);
+            }
+            needRegisterDriver = false;
+        }
+
+    }
+
+//    private static class ConnectionProvider {
+//
+//        private static boolean needRegisterDriver = true;
+//
+//
+//        private final H2SpatialConnectionParameters connectionParameters;
+//
+//        public ConnectionProvider(H2SpatialConnectionParameters connectionParameters) {
+//            this.connectionParameters = connectionParameters;
+//        }
+//
+//        public Connection getConnection() throws SQLException {
+//            if (!this.isRegistered()) {
+//                this.registerDriver();
+//            }
+//            Connection conn;
+//            if( !StringUtils.isEmpty(connectionParameters.getUser()) ) {
+//                conn = DriverManager.getConnection(
+//                    connectionParameters.getUrl(),
+//                    connectionParameters.getUser(),
+//                    connectionParameters.getPassword()
+//                );
+//            } else {
+//                conn = DriverManager.getConnection(connectionParameters.getUrl());
+//            }
+//            try {
+//                conn.createStatement().execute("SELECT TOP 1 SRID FROM SPATIAL_REF_SYS");
+//            } catch(SQLException ex) {
+//                H2GISExtension.load(conn);
+//            }
+//            return conn;
+//        }
+//
+//        private boolean isRegistered() {
+//            return needRegisterDriver;
+//        }
+//
+//        public void registerDriver() throws SQLException {
+//            String className = this.connectionParameters.getJDBCDriverClassName();
+//            if (className == null) {
+//                return;
+//            }
+//            try {
+//                Class theClass = Class.forName(className);
+//                if (theClass == null) {
+//                    throw new JDBCDriverClassNotFoundException(H2SpatialLibrary.NAME, className);
+//                }
+//            } catch (Exception e) {
+//                throw new SQLException("Can't register JDBC driver '" + className + "'.", e);
+//            }
+//            needRegisterDriver = false;
+//        }
+//
+//    }
+
+    private ConnectionProvider connectionProvider = null;
+   
+    public H2SpatialHelper(JDBCConnectionParameters connectionParameters) {
+        super(connectionParameters);
+        this.srss = new JDBCSRSsBase(this);
+    }
+
+    @Override
+    public synchronized Connection  getConnection() throws AccessResourceException {
+        try {
+            if (this.connectionProvider == null) {
+                this.connectionProvider = new ConnectionProvider(this.getConnectionParameters());
+            }
+            Connection connection = this.connectionProvider.getConnection();
+            logger.debug("getConnection: connection = "+connection.hashCode());
+            return connection;
+        } catch (SQLException ex) {
+            throw new AccessResourceException(H2SpatialLibrary.NAME, ex);
+        }
+    }
+
+    @Override
+    public void closeConnection(Connection connection) {
+        logger.debug("closeConnection: connection = "+connection.hashCode());
+        super.closeConnection(connection);
+    }
+    
+    @Override
+    public H2SpatialConnectionParameters getConnectionParameters() {
+        return (H2SpatialConnectionParameters) super.getConnectionParameters();
+    }
+    
+    @Override
+    public String getConnectionURL() {
+        return getConnectionURL(this.getConnectionParameters());
+    }
+
+    @Override
+    protected String getResourceType() {
+        return H2SpatialLibrary.NAME;
+    }
+
+    @Override
+    public String getProviderName() {
+        return H2SpatialLibrary.NAME;
+    }
+
+    @Override
+    public JDBCSQLBuilderBase createSQLBuilder() {
+        return new H2SpatialSQLBuilder(this);
+    }
+    
+    @Override
+    public OperationsFactory getOperations() {
+        if (this.operationsFactory == null) {
+            this.operationsFactory = new H2SpatialOperationsFactory(this);
+        }
+        return operationsFactory;
+    }
+
+    @Override
+    public SQLBuilder.GeometrySupportType getGeometrySupportType() {
+        return SQLBuilder.GeometrySupportType.WKB;
+    }
+
+    @Override
+    public boolean hasSpatialFunctions() {
+        return true;
+    }
+
+    @Override
+    public boolean canWriteGeometry(int geometryType, int geometrySubtype) {
+        return true;
+    }
+
+    @Override
+    public String getQuoteForIdentifiers() {
+        return "\"";
+    }
+
+    @Override
+    public boolean allowAutomaticValues() {
+        return true;
+    }
+
+    @Override
+    public boolean supportOffsetInSelect() {
+        return true;
+    }
+
+    @Override
+    public String getQuoteForStrings() {
+        return "'";
+    }
+
+    @Override
+    public int getSRSCode(IProjection crs) {
+        // TODO: ir a buscarlo a la BBDD a ver donde puede estar
+        return super.getSRSCode(crs);
+    }
+    
+    @Override
+    public IProjection getProjectionFromSRSId(int srsid) {
+        // TODO: ir a buscarlo a la BBDD a ver donde puede estar
+        return super.getProjectionFromSRSId(srsid);
+    }
+
+    @Override
+    public String getSourceId(JDBCStoreParameters parameters) {
+        return parameters.getDBName() + "." + 
+               parameters.getSchema()+ "." + 
+               parameters.getTable();
+    }
+
+    @Override
+    public JDBCNewStoreParameters createNewStoreParameters() {
+        return new H2SpatialNewStoreParameters();
+    }
+
+    @Override
+    public JDBCStoreParameters createOpenStoreParameters() {
+        return new H2SpatialStoreParameters();
+    }
+
+    @Override
+    public JDBCServerExplorerParameters createServerExplorerParameters() {
+        return new H2SpatialExplorerParameters();
+    }
+
+    public Geometry forceGeometryType(GeometryType geomtype, Geometry geom) throws CreateGeometryException {
+        switch( geomtype.getType() ) {
+        case Geometry.TYPES.MULTIPOLYGON:
+            if( geom.getType()==Geometry.TYPES.POLYGON ) {
+                MultiPolygon x = getGeometryManager().createMultiPolygon(geomtype.getSubType());
+                x.addPrimitive((Primitive) geom);
+                geom = x;
+            }
+            break;
+        case Geometry.TYPES.MULTILINE:
+            if( geom.getType()==Geometry.TYPES.LINE ) {
+                MultiLine x = getGeometryManager().createMultiLine(geomtype.getSubType());
+                x.addPrimitive((Primitive) geom);
+                geom = x;
+            }
+            break;
+        case Geometry.TYPES.MULTIPOINT:
+            if( geom.getType()==Geometry.TYPES.POINT ) {
+                MultiLine x = getGeometryManager().createMultiLine(geomtype.getSubType());
+                x.addPrimitive((Primitive) geom);
+                geom = x;
+            }
+            break;
+        case Geometry.TYPES.POLYGON:
+            if( geom.getType()==Geometry.TYPES.MULTIPOLYGON ) {
+                MultiPolygon x = (MultiPolygon) geom;
+                if( x.getPrimitivesNumber()==1 ) {
+                    geom = x.getPrimitiveAt(0);
+                }
+            }
+            break;
+        case Geometry.TYPES.LINE:
+            if( geom.getType()==Geometry.TYPES.MULTILINE ) {
+                MultiLine x = (MultiLine) geom;
+                if( x.getPrimitivesNumber()==1 ) {
+                    geom = x.getPrimitiveAt(0);
+                }
+            }
+            break;
+        case Geometry.TYPES.POINT:
+            if( geom.getType()==Geometry.TYPES.MULTIPOINT ) {
+                MultiPoint x = (MultiPoint) geom;
+                if( x.getPrimitivesNumber()==1 ) {
+                    geom = x.getPrimitiveAt(0);
+                }
+            }
+        }
+        return geom;
+    }
+    
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialStoreProviderFactory.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialStoreProviderFactory.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialStoreProviderFactory.java	(revision 43377)
@@ -0,0 +1,44 @@
+
+package org.gvsig.fmap.dal.store.h2;
+
+import org.gvsig.fmap.dal.DataParameters;
+import org.gvsig.fmap.dal.exception.InitializeException;
+import org.gvsig.fmap.dal.spi.DataStoreProviderServices;
+import org.gvsig.fmap.dal.store.jdbc.JDBCConnectionParameters;
+import org.gvsig.fmap.dal.store.jdbc.JDBCStoreParameters;
+import org.gvsig.fmap.dal.store.jdbc2.JDBCHelper;
+import org.gvsig.fmap.dal.store.jdbc2.JDBCStoreProvider;
+import org.gvsig.fmap.dal.store.jdbc2.impl.JDBCStoreProviderFactory;
+
+
+public class H2SpatialStoreProviderFactory extends JDBCStoreProviderFactory {
+
+    private static final String NAME = H2SpatialLibrary.NAME;
+    
+    public H2SpatialStoreProviderFactory() {
+        super(
+                NAME, 
+                "H2Spatial store"
+        );
+    }
+
+    @Override
+    public JDBCStoreProvider createProvider(
+            DataParameters parameters,
+            DataStoreProviderServices providerServices
+    ) throws InitializeException {
+        JDBCHelper helper = new H2SpatialHelper((JDBCConnectionParameters) parameters);
+        JDBCStoreProvider provider = helper.createProvider(
+                (JDBCStoreParameters) parameters, 
+                providerServices
+        );
+        return provider;
+    }
+
+    @Override
+    public JDBCStoreParameters createParameters() {
+        JDBCStoreParameters params = new H2SpatialStoreParameters();
+        return params;
+    }
+    
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialStoreParameters.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialStoreParameters.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialStoreParameters.java	(revision 43377)
@@ -0,0 +1,67 @@
+/* gvSIG. Geographic Information System of the Valencian Government
+*
+* Copyright (C) 2007-2008 Infrastructures and Transports Department
+* of the Valencian Government (CIT)
+*
+* This program is free software; you can redistribute it and/or
+* modify it under the terms of the GNU General Public License
+* as published by the Free Software Foundation; either version 2
+* of the License, or (at your option) any later version.
+*
+* This program is distributed in the hope that it will be useful,
+* but WITHOUT ANY WARRANTY; without even the implied warranty of
+* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+* GNU General Public License for more details.
+*
+* You should have received a copy of the GNU General Public License
+* along with this program; if not, write to the Free Software
+* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+* MA  02110-1301, USA.
+*
+ */
+package org.gvsig.fmap.dal.store.h2;
+
+import java.io.File;
+import java.util.Properties;
+import org.gvsig.fmap.dal.exception.ValidateDataParametersException;
+import org.gvsig.fmap.dal.store.jdbc.JDBCStoreParameters;
+
+public class H2SpatialStoreParameters extends JDBCStoreParameters implements H2SpatialConnectionParameters {
+
+    private final H2SpatialConnectionParametersHelper helper;
+    
+    public H2SpatialStoreParameters() {
+        super(
+                H2SpatialLibrary.NAME + "StoreParameters",
+                H2SpatialLibrary.NAME
+        );
+        this.helper = new H2SpatialConnectionParametersHelper(this);
+    }
+
+    @Override
+    public String getUrl() {
+        return this.helper.getUrl();
+    }
+    
+    @Override
+    public void validate() throws ValidateDataParametersException {
+        this.helper.validate();
+        super.validate();
+    }
+    
+    @Override
+    public Properties getProperties() {
+        return this.helper.getProperties();
+    }
+
+    @Override
+    public File getFile() {
+        return this.helper.getFile();
+    }
+    
+    @Override
+    public void setFile(File database) {
+        this.helper.setFile(database);
+    }
+
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialConnectionParameters.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialConnectionParameters.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialConnectionParameters.java	(revision 43377)
@@ -0,0 +1,11 @@
+
+package org.gvsig.fmap.dal.store.h2;
+
+import java.util.Properties;
+import org.gvsig.fmap.dal.serverexplorer.filesystem.FilesystemStoreParameters;
+import org.gvsig.fmap.dal.store.jdbc.JDBCConnectionParameters;
+
+public interface H2SpatialConnectionParameters extends JDBCConnectionParameters, FilesystemStoreParameters {
+    
+    public Properties getProperties();
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialConnectionParametersHelper.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialConnectionParametersHelper.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialConnectionParametersHelper.java	(revision 43377)
@@ -0,0 +1,97 @@
+package org.gvsig.fmap.dal.store.h2;
+
+import java.io.File;
+import java.util.Properties;
+import org.apache.commons.lang3.StringUtils;
+import org.gvsig.fmap.dal.DataParameters;
+import org.gvsig.fmap.dal.exception.ValidateDataParametersException;
+import org.gvsig.fmap.dal.resource.db.DBParameters;
+import org.gvsig.fmap.dal.store.jdbc.JDBCConnectionParameters;
+
+public class H2SpatialConnectionParametersHelper {
+
+    private final JDBCConnectionParameters parameters;
+
+    private static final String DATABASE_FILE = "database_file";
+
+    public H2SpatialConnectionParametersHelper(JDBCConnectionParameters parameters) {
+        this.parameters = parameters;
+    }
+
+    public String getUrl() {
+        String url = (String) this.getDynValue(JDBCConnectionParameters.URL_PARAMTER_NAME);
+        if( StringUtils.isEmpty(url) ) {
+            url = H2SpatialHelper.getConnectionURL((H2SpatialConnectionParameters) this.parameters);
+            this.setDynValue(JDBCConnectionParameters.URL_PARAMTER_NAME, url);
+        }
+        return url;
+    }
+
+    public void validate() throws ValidateDataParametersException {
+        if( this.getDynValue(JDBCConnectionParameters.JDBC_DRIVER_CLASS_PARAMTER_NAME) == null ) {
+            this.setDynValue(
+                JDBCConnectionParameters.JDBC_DRIVER_CLASS_PARAMTER_NAME,
+                H2SpatialHelper.H2SpatialJDBCDriver
+            );
+        }
+        if( getFile() == null ) {
+            if( this.getDynValue(JDBCConnectionParameters.DBNAME_PARAMTER_NAME) == null ) {
+                throw new ValidateDataParametersException();
+            } else {
+                setFile(new File((String) this.getDynValue(JDBCConnectionParameters.DBNAME_PARAMTER_NAME)));
+            }
+        } else {
+            String dbName = (String) this.getDynValue(JDBCConnectionParameters.DBNAME_PARAMTER_NAME);
+            if( StringUtils.isEmpty(dbName) ) {
+                dbName = getFile().getName();
+                int n = dbName.indexOf(".");
+                if( n > 0 ) {
+                    dbName = dbName.substring(0, n);
+                }
+                this.setDynValue(
+                    JDBCConnectionParameters.DBNAME_PARAMTER_NAME,
+                    dbName.toUpperCase()
+                );
+            }
+        }
+    }
+
+    private Object getDynValue(String name) {
+        return ((DataParameters) this.parameters).getDynValue(name);
+    }
+
+    private void setDynValue(String name, Object value) {
+        ((DataParameters) this.parameters).setDynValue(name, value);
+    }
+
+    public File getFile() {
+        File f = (File) this.getDynValue(DATABASE_FILE);
+        if( this.getDynValue(DBParameters.DBNAME_PARAMTER_NAME) == null
+            && f != null ) {
+            String dbname = f.getName();
+            if( dbname.endsWith(".mv.db") ) {
+                dbname = dbname.substring(0, dbname.length() - 6);
+            }
+            this.setDynValue(DBParameters.DBNAME_PARAMTER_NAME, dbname);
+        }
+        return f;
+    }
+
+    public void setFile(File database) {
+        this.setDynValue(DATABASE_FILE, database);
+        if( this.getDynValue(DBParameters.DBNAME_PARAMTER_NAME) == null
+            && database != null ) {
+            String dbname = database.getName();
+            if( dbname.endsWith(".mv.db") ) {
+                dbname = dbname.substring(0, dbname.length() - 6);
+            }
+            this.setDynValue(DBParameters.DBNAME_PARAMTER_NAME, dbname);
+        }
+    }
+
+    public Properties getProperties() {
+        Properties props = new Properties();
+        return props;
+    }
+
+}

Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/resources/META-INF/services/org.gvsig.tools.library.Library
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/resources/META-INF/services/org.gvsig.tools.library.Library	(revision 43376)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/resources/META-INF/services/org.gvsig.tools.library.Library	(revision 43377)
@@ -1 +1 @@
-org.gvsig.fmap.dal.store.h2.H2Library
\ No newline at end of file
+org.gvsig.fmap.dal.store.h2.H2SpatialLibrary
\ No newline at end of file
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc/JDBCServerExplorerBase.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc/JDBCServerExplorerBase.java	(revision 43376)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc/JDBCServerExplorerBase.java	(revision 43377)
@@ -605,4 +605,9 @@
         params.setTable(name);
         return params;
     }
+
+    @Override
+    public void execute(String sql) {
+        throw new UnsupportedOperationException("Not supported yet.");
+    }
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc/JDBCServerExplorer.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc/JDBCServerExplorer.java	(revision 43376)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc/JDBCServerExplorer.java	(revision 43377)
@@ -45,5 +45,7 @@
 
     void updateTableStatistics(String database, String schema, String table) throws JDBCExecuteSQLException;
     
+    public void execute(String sql);
+  
 }
 
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/JDBCServerExplorer.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/JDBCServerExplorer.java	(revision 43376)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/JDBCServerExplorer.java	(revision 43377)
@@ -1,7 +1,6 @@
 package org.gvsig.fmap.dal.store.jdbc2;
 
 import java.util.List;
-import org.gvsig.fmap.dal.DataServerExplorer;
 import org.gvsig.fmap.dal.DataStore;
 import org.gvsig.fmap.dal.DataStoreParameters;
 import org.gvsig.fmap.dal.NewDataStoreParameters;
@@ -62,5 +61,5 @@
 
     @Override
     public FeatureType getFeatureType(DataStoreParameters theParams) throws DataException;
-
+      
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/OperationsFactory.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/OperationsFactory.java	(revision 43376)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/OperationsFactory.java	(revision 43377)
@@ -24,6 +24,7 @@
 import org.gvsig.fmap.dal.store.jdbc2.spi.operations.DropTableOperation;
 import org.gvsig.fmap.dal.store.jdbc2.spi.operations.ResultSetForSetProviderOperation;
 import org.gvsig.fmap.dal.store.jdbc2.spi.operations.CountOperation;
+import org.gvsig.fmap.dal.store.jdbc2.spi.operations.ExecuteOperation;
 import org.gvsig.fmap.dal.store.jdbc2.spi.operations.UpdateTableStatisticsOperation;
 import org.gvsig.fmap.geom.primitive.Envelope;
 
@@ -38,7 +39,13 @@
             String defaultGeometryField,
             IProjection crs
     );
-
+    
+//    public FetchFeatureTypeOperation createFetchFeatureType(
+//                EditableFeatureType type, 
+//                String defaultGeometryField, 
+//                IProjection crs
+//    );
+//
     public FetchFeatureProviderByReferenceOperation createFetchFeatureProviderByReference(
             FeatureReferenceProviderServices reference,
             FeatureType featureType,
@@ -143,4 +150,7 @@
             String schemaName, 
             String tableName
     );
+    
+    public ExecuteOperation createExecute(String sql);
+    
 }
